import matplotlib.pyplot as plt
import numpy as np

def methods_comparator(cloud_x, cloud_y, a1, b1, a2, b2, lbl2):
    fig = plt.figure("Affichage du TP de M. Montandon (" + lbl2 +")")
    plt.title(lbl2)
    x1 = np.array(cloud_x)
    y1 = np.array(cloud_y)
    points = plt.scatter(x1, y1,marker="*", color="g")
    plt.xlabel('X')
    plt.ylabel('Y')
    plt.plot(x1, (a1*x1)+b1, linewidth=5.0, color= "m")
    plt.plot(x1, (a2*x1)+b2, linewidth=5.0, color= "c")
    plt.show()

def comparator_caller():

    lbl2 = "Solution Analytique VS Solution Numérique"

    all_x = []
    all_y = []
    abb_l = []

    cx = open('cloud.xx', 'r')
    for line_x in cx:
        xx,yx = line_x.split(" ")
        all_x.append(float(xx))
        all_y.append(float(yx))

    abb = open('comparator.lines', 'r')
    for line_abb in abb:
        abb_l.append(float(line_abb))


    # Uncomment the line if you want to display it :D
    methods_comparator(all_x, all_y, abb_l[0], abb_l[1], abb_l[2], abb_l[3], lbl2)

    
    cx.close()
    abb.close()



def gug(cloud_1x, cloud_1y, cloud_2x, cloud_2y, cloud_3x, cloud_3y, a1, b1, a2, b2, lbl):
    
    fig = plt.figure("Affichage du TP de M. Montandon (" + lbl +")")
    plt.title(lbl)
    cloud_1x.extend(cloud_2x)
    cloud_1y.extend(cloud_2y)
    x1 = np.array(cloud_1x)
    y1 = np.array(cloud_1y)
    x2 = np.array(cloud_3x)
    y2 = np.array(cloud_3y)
    model = plt.scatter(x1, y1,marker="*", color="m")
    test = plt.scatter(x2, y2,marker="d",color="c")
    plt.xlabel('X')
    plt.ylabel('Y')
    plt.legend((model,test),
    ('Points du modèle', 'Points du test'),
    scatterpoints=1,
    loc='lower right',
    ncol=2,
    fontsize=8)
    plt.plot(x1, (a1*x1)+b1, linewidth=5.0, color= "m")
    plt.plot(x2, (a2*x2)+b2, linewidth=5.0, color= "c")
    plt.show()

def validation():
    ca_x = []
    ca_y = []
    cb_x = []
    cb_y = []
    cc_x = []
    cc_y = []
    ab_l = []

    ca = open('cloud.aa', 'r')
    for line_a in ca:
        xa,ya = line_a.split(" ")
        ca_x.append(float(xa))
        ca_y.append(float(ya))

    cb = open('cloud.bb', 'r')
    for line_b in cb:
        xb,yb = line_b.split(" ")
        cb_x.append(float(xb))
        cb_y.append(float(yb))

    cc = open('cloud.cc', 'r')
    for line_c in cc:
        xc,yc = line_c.split(" ")
        cc_x.append(float(xc))
        cc_y.append(float(yc))

    ab = open('ab.lines', 'r')
    for line_ab in ab:
        ab_l.append(float(line_ab))


    # Il faut les lire un à la fois sinon il y a un bug d'affichage sur le troisième

    #G1 U G2 et test sur G3
    #gug(ca_x, ca_y, cb_x, cb_y, cc_x, cc_y, ab_l[0], ab_l[1], ab_l[2], ab_l[3], "G1 U G2 et test sur G3")
    #G1 U G3 et test sur G2
    gug(ca_x, ca_y, cc_x, cc_y, cb_x, cb_y, ab_l[4], ab_l[5], ab_l[6], ab_l[7],"G1 U G3 et test sur G2")
    #G2 U G3 et test sur G1
    #gug(cb_x, cb_y, cc_x, cc_y, ca_x, ca_y, ab_l[8], ab_l[9], ab_l[10], ab_l[11],"G2 U G3 et test sur G1")

    ca.close()
    cb.close()
    cc.close()
    ab.close()


# Choose one (comment/uncomment)
# If you choose validation(), go a few lines above 
# to choose which graph you want to see

#comparator_caller()
validation()